#! /usr/local/bin/perl

require "getopts.pl";

&Getopts('i:r:d:n:o:m:a:e');

#############################################

if (defined $opt_i) {
  $inp_list=$opt_i;
}
else {
  print "Give me please list of images ";
  chop($inp_list=<STDIN>);
}

if (defined $opt_r) {
  $ra=$opt_r;
}
else {
  print "Give me please RA ";
  chop($ra=<STDIN>);
}

if (defined $opt_d) {
  $dec=$opt_d;
}
else {
  print "Give me please DEC ";
  chop($dec=<STDIN>);
}


if (defined $opt_n) {
  $nbands=$opt_n;
}
else {
  print "Give me please number of energy bands ";
  chop($nbands=<STDIN>);
}

if (defined $opt_o) {
  $out_file=$opt_o;
}
else {
  print "Give me please the name of output file ";
  chop($out_file=<STDIN>);
}

if (defined $opt_m) {
  $rmf=$opt_m;
}
if (defined $opt_a) {
  $arf=$opt_a;
}

system "rm data.txt";
open (data,">data.txt");
$j=0;
#  print data "0 0. 0.0  1. 0 1 \n";

while ($j<$nbands){
  $i=0;
  $sum1[$j]=0;
  $sum2[$j]=0;
  $sum3[$j]=0;

  open (list, "<$inp_list");

  while (<list>){

    chomp;	
    $file=$_;
    if (-e $file) {
	  
      $imadol=2+$j*2;
      $sigdol=3+$j*2;
      $ima=$file."\[$imadol]";
      $sig=$file."\[$sigdol]";
      $cc=`sky2xy $ima $ra $dec`;
      (@a)=split(' ',$cc);

      $xf=$a[8]*1;
      $yf=$a[9]*1;
      ($x,$t)=split('\.',$xf);
      ($y,$t)=split('\.',$yf);
      
      if ($xf-$x >0.5) {
	$x=$x+1; 
      }
      if ($yf-$y >0.5) {
	$y=$y+1; 
      }
      

      $imadol=2+$j*2;
      $sigdol=3+$j*2;
      $ima=$file."\[$imadol]";
      $sig=$file."\[$sigdol]";
      $cc=`fimgdmp $ima STDOUT $x $x $y $y`;
      (@a)=split(' ',$cc);
      $imaval=$a[2];
      
      $cc=`fimgdmp $sig STDOUT $x $x $y $y`;
      (@a)=split(' ',$cc);
      $sigval=$a[2];
      $varval=($imaval/$sigval)**2;

      $cc=`fkeyprint $ima EXPOSURE`;
      (@a)=split(' ',$cc);
      $expval=$a[10];

      

      $sum1[$j]=$sum1[$j]+$imaval/$varval;
      $sum2[$j]=$sum2[$j]+1./$varval;
      $sum3[$j]=$sum3[$j]+$expval;
      $i++;
    } 
    else {
    	print "File $file doesn't exist.\n";
    }
  }
  $num_scw=$i;
  close(list);
  $flux[$j]=$sum1[$j]/$sum2[$j];
  $err[$j]= (1./$sum2[$j])**0.5;
  $exposure[$j]=$sum3[$j];

  $k=$j+1; 
  print "$k $flux[$j] 0.0  $err[$j] 0 1  \n";
  print data "$k $flux[$j] 0.0  $err[$j] 0 1 \n";
    $j++;
}
# $k=$j+1;
#  print data "$k 0. 0.0  1. 0 1 \n";

close(data);

system "dal_create obj_name=a.fits template=PICS-EVTS-SPE.tpl";
system  "fcreate PICS-EVTS-SPE.col data.txt aa.fits";
system "rm $out_file";
system "fmerge 'a.fits aa.fits' $out_file columns='channel,rate,sys_err,stat_err,quality,grouping' ";
system "rm a.fits";
system "rm aa.fits";
system  "fparkey $exposure[1] $out_file EXPOSURE";

if (defined $opt_m) {
  system " fparkey $rmf $out_file RESPFILE "; 
}
if (defined $opt_a) {
 system  " fparkey $arf $out_file ANCRFILE ";
}
